%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%posterior_mode_full.m
%
%This program:
%               is a script to get the posterior mode approximated by
%               numerically maximizing the log posterior likelihood
%               function for the non-truncated model
%
%       Simply change to the directory where this file is located, type
%       posterior_mode_full and the results will be saved in the file
%       posterior_mode_full.mat
%
%
%THIS VERSION: 1.0 March 27, 2009
%
%
%Copyright: Alexander Meyer-Gohde
%
%You are free to use/modify/redistribute this program so long as original
%authorship credit is given and you in no way impinge on its free
%distribution
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

load sw_2005_full;  
x=data(:,2);
hp_filter; %HP Filter the GDP data
data(:,2)=xhp;
data(:,1)=data(:,1)-mean(data(:,1));    %De-mean inflation
data(:,3)=data(:,3)-mean(data(:,3));    %De-mean interest rates
[T K]=size(data);

model_name='input_example_me';

Pmean=[0.5 0.1      1   0.5   0.125 0.5  0.5 0.5        0.1 0.1 0.1]; 
Pstd= [0.2 0.05  0.75   0.25  0.05  0.2   0.2  0.2 2      2 2];
Pvar=Pstd.^(2);
Ptype={'beta', 'beta', 'norm', 'norm', 'norm', 'beta', 'beta', 'beta', 'invgamma', 'invgamma', 'invgamma'};

Ttype={'beta', 'beta', 'gamma', 'gamma', 'gamma', 'beta', 'beta', 'beta', 'invgamma', 'invgamma', 'invgamma'};



selection_matrix=[1 2 3];

save_name='posterior_mode_full.mat';



Data=data';
Data=Data(:);
addpath('..\estimation_engine')
addpath('..\estimation_engine\sims_opt')
addpath('..\linlagex')
mode_estimates(Pmean,Pvar,Ptype,Ttype,selection_matrix,Data,T,K,model_name,Pmean,save_name)